
; ========================================================
;			
;    -- BSTVariables.inc --
;			Jay Sullivan
; ========================================================
  
;#################################################
;#                Macro
;#################################################



	$String MACRO sTEXT
		LOCAL szText
		.data
		 szText db sTEXT, 0
		.code
		EXITM <Offset szText>
	ENDM
	
	
	$Const MACRO Num
		result textequ @CatStr(<c_>,<%Num>)
	% IFNDEF result
		  .const 
		    result dd Num
		  .code
	  ENDIF
		EXITM <result>
	ENDM
	
	$fConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4__>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(<_>,@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL4_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL4 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	$float MACRO num
		OPVAL TEXTEQU %OPATTR (num)        ; "Op type"
		DECPT TEXTEQU %@InStr(1, num, <.>) ; "Decimal Point"
		
		IF     OPVAL AND 00010000y		; Register
			exitm <num>
		ELSEIF OPVAL AND 00000100y		; Immediate
			DUMMYSTR textequ @CatStr(num,<.0>)
			exitm $fConst(%DUMMYSTR)
		ELSEIF OPVAL AND 00000010y		; Memory reference
			exitm <num>
		ELSEIF DECPT NE 0				; Float
			exitm <$fConst(num)>
		ELSE							; Unknown
			.err <This is unknown: num -- OPATTR = OPVAL -- Not float>
		ENDIF
	ENDM
	
	
	$dConst MACRO Num
	 	IFIDN @SubStr(<Num>,1,1),<->
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL8__>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 		sgnlocation equ @InStr(1,%formatted,<->)
	 		formatted textequ @CatStr(@SubStr(%formatted,1,sgnlocation-1),@SubStr(%formatted,sgnlocation+1))   
	 	ELSE
	 		dotposition equ @InStr(2,<Num>,<.>)
			formatted textequ @CatStr(<c_REAL8_>,@SubStr(<Num>,1,dotposition-1),<_>,@SubStr(<Num>,dotposition+1))   
	 	ENDIF
		%IFNDEF formatted
		  .const 
		    formatted REAL8 Num
		  .code
	 	ENDIF
		EXITM <formatted>
	ENDM
	
	$double MACRO num
		OPVAL TEXTEQU %OPATTR (num)        ; "Op type"
		DECPT TEXTEQU %@InStr(1, num, <.>) ; "Decimal Point"
		
		IF     OPVAL AND 00010000y		; Register
			exitm <num>
		ELSEIF OPVAL AND 00000100y		; Immediate
			DUMMYSTR textequ @CatStr(num,<.0>)
			exitm $dConst(%DUMMYSTR)
		ELSEIF OPVAL AND 00000010y		; Memory reference
			exitm <num>
		ELSEIF DECPT NE 0				; Float
			exitm <$dConst(num)>
		ELSE							; Unknown
			.err <This is unknown: num -- OPATTR = OPVAL -- Not float>
		ENDIF
	ENDM

  
;#################################################
;#                Include
;#################################################
	include windows.inc
	include user32.inc
	include kernel32.inc
	include gdi32.inc
	includelib user32.lib
	includelib kernel32.lib
	includelib gdi32.lib
;#################################################
;#                .DATA
;#################################################
	.DATA
	ClassName		db "MainWinClass",0
	szAppName		db "BSTVariables",0
	MenuName		db "FirstMenu",0
	myFontFace		db "Courier New",0
	szCButton		db "BUTTON",0
	szCEdit			db "EDIT",0
	
aiElements dd  COLOR_ACTIVEBORDER, 
              COLOR_ACTIVECAPTION, 
                     COLOR_WINDOW
aColors dd 0808080h,
           0008080h,
           0C0C0C0h
           
	ITEM STRUCT 
		pRight dd ?
		pLeft dd ?
		pName dd ?
		dwNameLength dd ?
		pData dd ?
		dwDataLength dd ?
	ITEM ENDS
	
	Emm db 'm',0
	EmptyString db 0
	
	ROOTITEM			ITEM <0,0,Offset Emm,1,Offset EmptyString,0>
	
	myTextRect RECT <70,110,110,135>
	TreeSize 	 dd 0
	TreeSizeA	 DWORD 030303030h
	
	.DATA?
	
	hInstance		HINSTANCE ?
	CommandLine		LPSTR ?
	hMenu			HMENU ?
	hHeap			HANDLE ?
	hButtonSet		HWND ?
	hButtonGet		HWND ?
	hEditKW			HWND ?
	hEditDATA		HWND ?
	hButtonDump		HWND ?
	hwnd			HWND ?
	hf14			HFONT ?
;#################################################
;#                EQU
;#################################################
	IDM_FILE_NEW	EQU 1
	IDM_FILE_OPEN	EQU 2
	IDM_HELP_ABOUT	EQU 3
	IDM_FILE_EXIT	EQU 4
	IDB_TREE 		EQU 4006
